%module swig_uuid
%{
#include <uuid/uuid.h>
%}

typedef unsigned char uuid_t[16];

%inline %{
unsigned char *new_uuid_t(void)
{
	return (unsigned char *)emalloc(sizeof(uuid_t));
}

char *new_charp(void)
{
	return (char *)emalloc(sizeof(char));
}

char *get_char(char *out)
{
	return (char *)out;
}
%}


void uuid_clear(uuid_t uu);
int uuid_compare(const uuid_t uu1, const uuid_t uu2);
void uuid_copy(uuid_t dst, const uuid_t src);
void uuid_generate(uuid_t out);
void uuid_generate_random(uuid_t out);
void uuid_generate_time(uuid_t out);
int uuid_is_null(const uuid_t uu);
int uuid_parse(const char *in, uuid_t uu);
void uuid_unparse(const uuid_t uu, char *out);
time_t uuid_time(const uuid_t uu, struct timeval *ret_tv);
int uuid_type(const uuid_t uu);
int uuid_variant(const uuid_t uu);
